Bug 664812 - Review Request: perl-HTML-Quoted - Extract structure of quoted HTML mail message
Summary: Review Request: perl-HTML-Quoted - Extract structure of quoted HTML mail message
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Petr Pisar
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: rt4-dependencies-tracker
TreeView+ depends on / blocked
 
Reported: 2010-12-21 18:14 UTC by Ralf Corsepius
Modified: 2011-02-04 19:53 UTC (History)
4 users (show)

Fixed In Version: perl-HTML-Quoted-0.03-1.fc14
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-02-04 19:49:19 UTC
Type: ---
ppisar: fedora-review+
j: fedora-cvs+


Attachments (Terms of Use)

Description Ralf Corsepius 2010-12-21 18:14:28 UTC
Spec URL: http://corsepiu.fedorapeople.org/packages/perl-HTML-Quoted.spec
SRPM URL: http://corsepiu.fedorapeople.org/packages/perl-HTML-Quoted-0.02-1.fc15.src.rpm
Description:
Extract structure of quoted HTML mail message

Comment 1 Petr Pisar 2011-01-06 10:31:34 UTC
Source tar ball is original. Ok.
Summary verified from lib/HTML/Quoted.pm. Ok.
License verified from lib/HTML/Quoted.pm. Ok.
Description copied from Summary because there is no better. Ok.

TODO: Add full stop on the end of Description. You can use %{summary} macro to refer the text.

FIX: BuildRequire perl(Data::Dumper) (t/lines.t) as it can dual-live in the future (http://search.cpan.org/~smueller/Data-Dumper/)

All tests pass. Ok.

$ rpmlint perl-HTML-Quoted.spec ../SRPMS/perl-HTML-Quoted-0.02-1.fc14.src.rpm ../RPMS/noarch/perl-HTML-Quoted-0.02-1.fc14.noarch.rpm 
2 packages and 1 specfiles checked; 0 errors, 0 warnings.
rpmlint Ok.

$ rpm -pqlv ../RPMS/noarch/perl-HTML-Quoted-0.02-1.fc14.noarch.rpm 
drwxr-xr-x    2 root    root                        0 led  6 11:08 /usr/share/doc/perl-HTML-Quoted-0.02
-rw-r--r--    1 root    root                       94 úno 27  2010 /usr/share/doc/perl-HTML-Quoted-0.02/Changes
-rw-r--r--    1 root    root                      252 úno 27  2010 /usr/share/doc/perl-HTML-Quoted-0.02/README
-rw-r--r--    1 root    root                     1865 led  6 11:08 /usr/share/man/man3/HTML::Quoted.3pm.gz
drwxr-xr-x    2 root    root                        0 led  6 11:08 /usr/share/perl5/HTML
-rw-r--r--    1 root    root                     6604 úno 27  2010 /usr/share/perl5/HTML/Quoted.pm
File permissions and layout Ok.

$ rpm -pq --requires ../RPMS/noarch/perl-HTML-Quoted-0.02-1.fc14.noarch.rpm |sort |uniq -c
      1 perl(base)  
      1 perl(:MODULE_COMPAT_5.12.2)  
      1 perl(strict)  
      1 perl(warnings)  
      1 perl >= 0:5.008
      1 rpmlib(CompressedFileNames) <= 3.0.4-1
      1 rpmlib(FileDigests) <= 4.6.0-1
      1 rpmlib(PayloadFilesHavePrefix) <= 4.0-1
      1 rpmlib(PayloadIsXz) <= 5.2-1
      1 rpmlib(VersionedDependencies) <= 3.0.3-1
FIX: Require perl(HTML::Parser) >= 3.0 (lib/HTML/Quoted.pm:40, META.yml:22)

$ rpm -pq --provides ../RPMS/noarch/perl-HTML-Quoted-0.02-1.fc14.noarch.rpm |sort |uniq -c
      1 perl(HTML::Quoted::Parser)  
      1 perl(HTML::Quoted) = 0.02
      1 perl-HTML-Quoted = 0.02-1.fc14
Binary provides Ok.

$ resolvedeps-f15 ../RPMS/noarch/perl-HTML-Quoted-0.02-1.fc14.noarch.rpm 
Binary dependencies resolvable. Ok.

Package builds in F15 (http://koji.fedoraproject.org/koji/taskinfo?taskID=2704263). Ok.

Otherwise package is in line with Fedora and perl packaging guide lines.


Please correct all `FIX' prefixed issues and submit new spec file. Please consider fixing all `TODO' issues.
Resolution: Package NOT approved.

Comment 2 Ralf Corsepius 2011-01-20 16:25:34 UTC
(In reply to comment #1)

> TODO: Add full stop on the end of Description. You can use %{summary} macro to
> refer the text.
Done.
 
> FIX: BuildRequire perl(Data::Dumper) (t/lines.t) as it can dual-live in the
> future (http://search.cpan.org/~smueller/Data-Dumper/)
I don't have much of a problem in making this implict deps explicit, except that I do not agree with your rationale and except that it's currently technically not required:

- In general, we can not take into account any module which may be split out from the core perl-package at some point in more or less distant future.

- When a module is actually being split out, building packages which depend upon such module will break and make this change explicit.


Update:

Spec URL: http://corsepiu.fedorapeople.org/packages/perl-HTML-Quoted.spec
SRPM URL:
http://corsepiu.fedorapeople.org/packages/perl-HTML-Quoted-0.03-1.fc15.src.rpm

Comment 3 Petr Pisar 2011-01-21 11:32:11 UTC
Spec file changes:

--- perl-HTML-Quoted.spec	2010-12-21 19:12:04.000000000 +0100
+++ perl-HTML-Quoted.spec.1	2011-01-20 17:25:03.000000000 +0100
@@ -1,5 +1,5 @@
 Name:           perl-HTML-Quoted
-Version:        0.02
+Version:        0.03
 Release:        1%{?dist}
 Summary:        Extract structure of quoted HTML mail message
 License:        GPL+ or Artistic
@@ -8,14 +8,14 @@
 Source0:        http://www.cpan.org/authors/id/R/RU/RUZ/HTML-Quoted-%{version}.tar.gz
 BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
 BuildArch:      noarch
-BuildRequires:  perl >= 1:5.8.0
 BuildRequires:  perl(ExtUtils::MakeMaker)
 BuildRequires:  perl(HTML::Parser) >= 3.0
 BuildRequires:  perl(Test::More)
+BuildRequires:  perl(Data::Dumper)
 Requires:       perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
 
 %description
-Extract structure of quoted HTML mail message
+Extract structure of quoted HTML mail message.
 
 %prep
 %setup -q -n HTML-Quoted-%{version}
@@ -47,5 +47,8 @@
 %{_mandir}/man3/*
 
 %changelog
+* Thu Jan 20 2011 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.03-1
+- Upstream update.
+
 * Tue Dec 21 2010 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.02-1
 - Initial Fedora package.


No Changes in dependencies of sources.

Changes in dependencies of tests:
+use strict;
+use warnings;
+use Test::More tests => 1;
+use HTML::Quoted;
+use Data::Dumper;

No significant changes in META.yml.


Source file original. Ok.

> TODO: Add full stop on the end of Description. You can use %{summary} macro
> to refer the text.
-Extract structure of quoted HTML mail message
+Extract structure of quoted HTML mail message.
Ok.

> FIX: BuildRequire perl(Data::Dumper) (t/lines.t) as it can dual-live in the
> future (http://search.cpan.org/~smueller/Data-Dumper/)
+BuildRequires:  perl(Data::Dumper)
Ok.

Build-time dependecies Ok.

All tests pass. Ok.

$ rpmlint perl-HTML-Quoted.spec ../SRPMS/perl-HTML-Quoted-0.03-1.fc14.src.rpm ../RPMS/noarch/perl-HTML-Quoted-0.03-1.fc14.noarch.rpm 
2 packages and 1 specfiles checked; 0 errors, 0 warnings.
rpmlint Ok.

$ rpm -q -lv -p ../RPMS/noarch/perl-HTML-Quoted-0.03-1.fc14.noarch.rpm 
drwxr-xr-x    2 root    root                        0 led 21 10:23 /usr/share/doc/perl-HTML-Quoted-0.03
-rw-r--r--    1 root    root                      277 led  9 05:55 /usr/share/doc/perl-HTML-Quoted-0.03/Changes
-rw-r--r--    1 root    root                     1787 led  9 06:59 /usr/share/doc/perl-HTML-Quoted-0.03/README
-rw-r--r--    1 root    root                     2576 led 21 10:23 /usr/share/man/man3/HTML::Quoted.3pm.gz
drwxr-xr-x    2 root    root                        0 led 21 10:23 /usr/share/perl5/HTML
-rw-r--r--    1 root    root                     8176 led  9 06:59 /usr/share/perl5/HTML/Quoted.pm
File permissions and layout Ok.

> FIX: Require perl(HTML::Parser) >= 3.0 (lib/HTML/Quoted.pm:40, META.yml:22)
$ rpm -q --requires -p ../RPMS/noarch/perl-HTML-Quoted-0.03-1.fc14.noarch.rpm | sort | uniq -c 
      1 perl(base)  
      1 perl(:MODULE_COMPAT_5.12.2)  
      1 perl(strict)  
      1 perl(warnings)  
      1 perl >= 0:5.008
      1 rpmlib(CompressedFileNames) <= 3.0.4-1
      1 rpmlib(FileDigests) <= 4.6.0-1
      1 rpmlib(PayloadFilesHavePrefix) <= 4.0-1
      1 rpmlib(PayloadIsXz) <= 5.2-1
      1 rpmlib(VersionedDependencies) <= 3.0.3-1
FIX: Require perl(HTML::Parser) >= 3.0 (lib/HTML/Quoted.pm:98, META.yml:22)

$ rpm -q --provides -p ../RPMS/noarch/perl-HTML-Quoted-0.03-1.fc14.noarch.rpm | sort | uniq -c 
      1 perl(HTML::Quoted::Parser)  
      1 perl(HTML::Quoted) = 0.03
      1 perl-HTML-Quoted = 0.03-1.fc14
Binary provides Ok.

$ resolvedeps-f15 ../RPMS/noarch/perl-HTML-Quoted-0.03-1.fc14.noarch.rpm 
Binary dependencies resolvable. Ok.

Package builds in F15 (http://koji.fedoraproject.org/koji/taskinfo?taskID=2734607). Ok.


Please correct all `FIX' prefixed issues and submit new spec file.
Resolution: Package NOT approved.

Comment 4 Ralf Corsepius 2011-01-26 11:51:28 UTC
(In reply to comment #3)
> FIX: Require perl(HTML::Parser) >= 3.0 (lib/HTML/Quoted.pm:98, META.yml:22)

HTML::Parser 3.00 was released > 11 years ago:

cf. http://cpansearch.perl.org/src/GAAS/HTML-Parser-3.68/Changes:
...
1999-12-14   Gisle Aas <gisle@aas.no>

    Release 3.00
...

=> This Requires: is without any practical use.

Comment 5 Petr Pisar 2011-01-26 13:30:25 UTC
Ok, you think version specification is useless. I'm O.k. without it.

But what do you think about the HTML::Parser name itself. Don't you think it's missing in list of requires?

Comment 6 Ralf Corsepius 2011-01-26 13:56:52 UTC
Interesting - Fedora 15's rpm seems to catch it, while F13's and F15's rpm 
miss it:

$ rpm -q --requires -p perl-HTML-Quoted-0.03-1.fc13.noarch.rpm 
perl >= 0:5.008
perl(:MODULE_COMPAT_5.10.1)  
perl(base)  
perl(strict)  
perl(warnings)  
rpmlib(CompressedFileNames) <= 3.0.4-1
rpmlib(FileDigests) <= 4.6.0-1
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rpmlib(VersionedDependencies) <= 3.0.3-1
rpmlib(PayloadIsXz) <= 5.2-1

$ rpm -q --requires -p perl-HTML-Quoted-0.03-1.fc14.noarch.rpm 
perl >= 0:5.008
perl(:MODULE_COMPAT_5.12.2)  
perl(base)  
perl(strict)  
perl(warnings)  
rpmlib(CompressedFileNames) <= 3.0.4-1
rpmlib(FileDigests) <= 4.6.0-1
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rpmlib(VersionedDependencies) <= 3.0.3-1
rpmlib(PayloadIsXz) <= 5.2-1

$ rpm -q --requires -p perl-HTML-Quoted-0.03-1.fc15.noarch.rpm 
perl >= 0:5.008
perl(:MODULE_COMPAT_5.12.2)  
perl(HTML::Parser)  
perl(base)  
perl(strict)  
perl(warnings)  
rpmlib(CompressedFileNames) <= 3.0.4-1
rpmlib(FileDigests) <= 4.6.0-1
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rpmlib(PayloadIsXz) <= 5.2-1

All packages built in local mocks on fedora-14 from 
http://corsepiu.fedorapeople.org/packages/perl-HTML-Quoted-0.03-1.fc15.src.rpm

Panu, any insights?

Comment 7 Petr Pisar 2011-01-26 14:20:46 UTC
New rpm has been pushed into F15 improving dependencies generators. So it's O.k. in F15 now.

And this the reason why I like over-specifying dependencies in spec file than missing them later because of rpmbuild change. Actually I'd like to see rpmbuild to filter out duplicate/unneeded dependencies automatically resulting in solid spec file and light-weighted binary packages.


Resolution: Package APPROVED.

Comment 8 Ralf Corsepius 2011-01-26 14:40:22 UTC
(In reply to comment #7)
> New rpm has been pushed into F15 improving dependencies generators.

Issues like this are why I consider not fixing known bugs (here: rpm's perl deptracking) in actively maintained releases to be negligent.

... We now should check all perl binary rpms in all active releases and check if they are missing deps ...

Comment 9 Ralf Corsepius 2011-01-26 14:43:29 UTC
Anyway, thanks for the review!

New Package SCM Request
=======================
Package Name: perl-HTML-Quoted
Short Description: Extract structure of quoted HTML mail message
Owners: corsepiu
Branches: f13 f14
InitialCC: perl-sig

Comment 10 Panu Matilainen 2011-01-26 15:26:55 UTC
Being completely illiterate wrt perl, I can only guess that new dependency comes from Ville Skyttä's "extract dependencies from 'use base qw' syntax" enhancements. I've no clue how common that syntax might be, but as this is a completely new thing in rpm 4.9.x such dependencies would have been missed by all older rpm versions.

Comment 11 Ralf Corsepius 2011-01-26 16:04:19 UTC
(In reply to comment #10)
> Being completely illiterate wrt perl, I can only guess that new dependency
> comes from Ville Skyttä's "extract dependencies from 'use base qw' syntax"
> enhancements.

OK, this would be an explanation. The particular use-case is of kind you mention:  use base "HTML::Parser";

While we're at it: In another package, I encountered a case where f15's rpms
"use base" parser fails to detect a dependency:

use base # comment
    Some::Module;

Real world case: perl-Convert-Color in git (c.f. Convert-Color-0.07.diff)

Anyway this is OT for this BZ. I should likely file a BZ against rpm.

Comment 12 Jason Tibbitts 2011-01-26 17:56:08 UTC
Git done (by process-git-requests).

Comment 13 Fedora Update System 2011-01-27 02:10:18 UTC
perl-HTML-Quoted-0.03-1.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/perl-HTML-Quoted-0.03-1.fc14

Comment 14 Fedora Update System 2011-01-27 02:10:25 UTC
perl-HTML-Quoted-0.03-1.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/perl-HTML-Quoted-0.03-1.fc13

Comment 15 Ralf Corsepius 2011-01-27 02:18:01 UTC
Package built for f15. Packages for f14 and f15 are stuck in Fedora QA's delay queue.

Comment 16 Fedora Update System 2011-01-27 21:00:30 UTC
perl-HTML-Quoted-0.03-1.fc14 has been pushed to the Fedora 14 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update perl-HTML-Quoted'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/perl-HTML-Quoted-0.03-1.fc14

Comment 17 Fedora Update System 2011-02-04 19:49:13 UTC
perl-HTML-Quoted-0.03-1.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 18 Fedora Update System 2011-02-04 19:53:33 UTC
perl-HTML-Quoted-0.03-1.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.